#!/bin/sh

PKG_STR_WIZARD_UPDATE_TITLE="Install Synology Drive Server"
PKG_STR_WIZARD_UPDATE_DESC_CLOUD="Synology Drive Server is the successor to Cloud Station."
PKG_STR_WIZARD_UPDATE_DESC_OFFICE="Synology Drive Server is a universal file portal which integrates Synology Office."
PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE="Synology Drive Server is the successor to Cloud Station and serves as the portal to Synology Office."

PKG_STR_WIZARD_INSTALL_ACTIVATE="var form=arguments[0];var isCloudStationMigrate=__IS_CLOUD_MIGRATE__,isShareSyncMigrate=__IS_SHARESYNC_MIGRATE__,isOfficeMigrate=__IS_OFFICE_MIGRATE__,isClientUpgradeNeeded=__IS_CLINET_UPGRADE_NEEDED__;if(1===form.items.items.length){var note=\\\"\\\";if(isCloudStationMigrate){note+=\\\"<li>\\\"+\\\"<b>Cloud Station Server</b> will be replaced: data and settings in <b>Cloud Station Server</b> will be migrated to <b>Synology Drive Server</b>\\\"+\\\"</li>\\\"}if(isClientUpgradeNeeded){note+=\\\"<li>\\\"+\\\"Before upgrading to <b>Synology Drive Server</b>, please note that all Cloud Station Suite applications (Cloud Station Drive, Backup, ShareSync, or DS cloud) must be switched to the latest version of their counterparts in the Synology Drive Suite to ensure compatibility.\\\"+\\\"</li>\\\"}if(isShareSyncMigrate){note+=\\\"<li>\\\"+\\\"<b>Cloud Station ShareSync</b> will be replaced: data and settings in <b>Cloud Station ShareSync</b> will be migrated safely to <b>Synology Drive Server</b>\\\"+\\\"</li>\\\"}if(isOfficeMigrate){note+=\\\"<li>\\\"+\\\"<b>Synology Office</b> will be integrated: data in <b>Synology Office</b> will be migrated safely to <b>Synology Drive Server</b> and can be opened via the universal <b>Synology Drive</b> portal.\\\"+\\\"</li>\\\"}note+=\\\"<li>\\\"+\\\"Rollback is not supported\\\"+\\\"</li>\\\";form.add(new SYNO.ux.DisplayField({htmlEncode:false,value:\\\"Before installing Synology Drive Server, please note the following:\\\"+\\\"<br>\\\"+\\\"<ul style='padding-left:5px;list-style:disc inside;'>\\\"+note+\\\"</ul><br><span>\\\"+\\\"Visit <a target=\\\\"_blank\\\\" href=\\\\"https://www.synology.com/knowledgebase/DSM/tutorial/Collaboration/What_do_I_need_to_know_before_upgrading_from_Cloud_Station_to_Synology_Drive_2_0\\\\">here</a> for more information before upgrading to Synology Drive Server.\\\"+\\\"</span>\\\"}));form.doLayout()}if(isCloudStationMigrate||isShareSyncMigrate){var container=arguments[1];var nextStepButton=container.owner.getFooterToolbar().getComponent('next');var backStepButton=container.owner.getFooterToolbar().getComponent('back');var clickEventListeners=[];nextStepButton.mons.forEach(function(item){if(item.ename==='click'){clickEventListeners.push(item)}});clickEventListeners.forEach(function(item){nextStepButton.mun(item.item,item.ename,item.fn,item.scope)});var onClickNextButton=function(e){var msgDescription=\\\"\\\";if(isCloudStationMigrate&&isShareSyncMigrate){msgDescription=\\\"Cloud Station Server and Cloud Station ShareSync will be replaced by Synology Drive Server after installation, and their settings will be migrated. Do you want to continue?\\\"}else if(isCloudStationMigrate){msgDescription=\\\"Cloud Station Server will be replaced by Synology Drive Server after installation, and its settings will be migrated. Do you want to continue?\\\"}else if(isShareSyncMigrate){msgDescription=\\\"Cloud Station ShareSync will be replaced by Synology Drive Server after installation, and its settings will be migrated. Do you want to continue?\\\"}form.owner.getMsgBox().confirm(\\\"\\\",msgDescription,function(button){if(button==='yes'){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton);nextStepButton.el.dom.click()}})};var onClickBackButton=function(e){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton)};nextStepButton.mon(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mon(backStepButton.el,'click',onClickBackButton,backStepButton)}"

OFFICE_PKG_PATH="/var/packages/Spreadsheet/"
OFFICE_INFO_FILE=${OFFICE_PKG_PATH}"INFO"
CLOUDSTATION_PKG_PATH="/var/packages/CloudStation/"
CLOUDSTATION_DB_CONFIG_PATH=${CLOUDSTATION_PKG_PATH}"etc/db-path.conf"
CLOUDSTATION_USER_DB_RELATIVE_PATH="@cloudstation/@sync/user-db.sqlite"
CLOUDSTATIONCLIENT_PKG_PATH="/var/packages/CloudStationClient/"
VER_KEY="version"
OLD_OFFICE_MAJOR_VERSION=2
OLD_OFFICE_MINOR_VERSION=2

IsOfficeMigrate()
{
	if [ ! -f "${OFFICE_INFO_FILE}" ]; then
		return 0
	fi

	local office_major=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 1)
	local office_minor=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 2)

	if [ ${office_major} -lt ${OLD_OFFICE_MAJOR_VERSION} ] || [ ${office_major} -eq ${OLD_OFFICE_MAJOR_VERSION} -a ${office_minor} -le ${OLD_OFFICE_MINOR_VERSION} ]; then
		return 1
	fi
	return 0
}

IsCloudStationMigrate()
{
	if [ -d ${CLOUDSTATION_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

IsCloudStationClientMigrate()
{
	if [ -d ${CLOUDSTATIONCLIENT_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

IsClientUpgradeNeeded()
{
	IsCloudStationMigrate
	local cloud_station_migrate=$?

	if [ "${cloud_station_migrate}" = "0" ]; then
		return 0
	fi

	if [ ! -f "${CLOUDSTATION_DB_CONFIG_PATH}" ]; then
		return 0
	fi

	local db_volume=$(/usr/bin/get_key_value "${CLOUDSTATION_DB_CONFIG_PATH}" "db-vol")

	if [ -z "${db_volume}" ]; then
		return 0
	fi

	local user_db_path="${db_volume}/${CLOUDSTATION_USER_DB_RELATIVE_PATH}"

	if [ -f "${user_db_path}" ]; then
		local result=$(/usr/bin/sqlite3 "${user_db_path}" "SELECT EXISTS (SELECT 1 FROM session_table as st, user_table as ut WHERE ut.id = st.uid);")

		if [ "$result" = "1" ]; then
			return 1
		fi
	fi

	return 0
}

main()
{
	local InstallPages=""
	IsOfficeMigrate
	local office_migrate=$?
	IsCloudStationMigrate
	local cloud_migrate=$?
	IsCloudStationClientMigrate
	local sharesync_migrate=$?
	IsClientUpgradeNeeded
	local client_upgrade_needed=$?

	if [ "$office_migrate" = "0" ] && [ "$cloud_migrate" = "0" ] && [ "$sharesync_migrate" = "0" ]; then
		InstallPages=""
	else
		local title=${PKG_STR_WIZARD_UPDATE_TITLE}
		local description
		local activate=${PKG_STR_WIZARD_INSTALL_ACTIVATE}

		if [ "$office_migrate" = "0" ]; then
			description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD}
		else
			if [ "$cloud_migrate" = "1" ] || [ "$sharesync_migrate" = "1" ]; then
				description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE}
			else
				description=${PKG_STR_WIZARD_UPDATE_DESC_OFFICE}
			fi
		fi

		if [ "$office_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/false/g'`
		fi
		if [ "$cloud_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/false/g'`
		fi
		if [ "$sharesync_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/false/g'`
		fi
		if [ "$client_upgrade_needed" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLINET_UPGRADE_NEEDED__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLINET_UPGRADE_NEEDED__/false/g'`
		fi

		InstallPages=`/bin/cat<<EOF
{
	"step_title": "${title}",
	"activeate": "{${activate}}",
	"items": [{
		"desc": "${description}"
	}]
}
EOF`
	fi

/bin/cat > ${SYNOPKG_TEMP_LOGFILE} <<EOF
[${InstallPages}]
EOF

	exit 0
}

main "$@"
