#!/bin/sh

PKG_STR_WIZARD_UPDATE_TITLE="A Synology Drive Server telepítése"
PKG_STR_WIZARD_UPDATE_DESC_CLOUD="A Synology Drive Server a Cloud Station utódja."
PKG_STR_WIZARD_UPDATE_DESC_OFFICE="A Synology Drive Server egy univerzális fájlportál, amely a Synology Office alkalmazást is integrálni fogja."
PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE="A Synology Drive Server a Cloud Station utódja, és a Synology Office portáljaként fog működni."

PKG_STR_WIZARD_INSTALL_ACTIVATE="var form=arguments[0];var isCloudStationMigrate=__IS_CLOUD_MIGRATE__,isShareSyncMigrate=__IS_SHARESYNC_MIGRATE__,isOfficeMigrate=__IS_OFFICE_MIGRATE__,isClientUpgradeNeeded=__IS_CLINET_UPGRADE_NEEDED__;if(1===form.items.items.length){var note=\\\"\\\";if(isCloudStationMigrate){note+=\\\"<li>\\\"+\\\"A <b>Cloud Station Server</b> helyettesítése: a <b>Cloud Station Server</b> adatai és beállításai átkerülnek a <b>Synology Drive Server</b> alá\\\"+\\\"</li>\\\"}if(isClientUpgradeNeeded){note+=\\\"<li>\\\"+\\\"A <b>Synology Drive Server</b> szolgáltatásra való frissítés előtt ügyeljen arra, hogy a Cloud Station Suite összes alkalmazásánál (Cloud Station Drive, Backup, ShareSync vagy DS cloud) a kompatibilitás biztosításához a Synology Drive Suite megfelelő alkalmazásának legújabb verziójára kell váltania.\\\"+\\\"</li>\\\"}if(isShareSyncMigrate){note+=\\\"<li>\\\"+\\\"A <b>Cloud Station ShareSync</b> helyettesítése: a <b>Cloud Station ShareSync</b> adatai és beállításai átkerülnek a <b>Synology Drive Server</b> alá\\\"+\\\"</li>\\\"}if(isOfficeMigrate){note+=\\\"<li>\\\"+\\\"A <b>Synology Office</b> integrálása: a <b>Synology Office</b> alatt tárolt adatok átkerülnek a <b>Synology Drive Server</b> alá, és az univerzális <b>Synology Drive</b> portálon keresztül nyithatók meg.\\\"+\\\"</li>\\\"}note+=\\\"<li>\\\"+\\\"A visszalépés nem támogatott\\\"+\\\"</li>\\\";form.add(new SYNO.ux.DisplayField({htmlEncode:false,value:\\\"A Synology Drive Server telepítése előtt felhívjuk figyelmét a következőkre:\\\"+\\\"<br>\\\"+\\\"<ul style='padding-left:5px;list-style:disc inside;'>\\\"+note+\\\"</ul><br><span>\\\"+\\\"A Synology Drive Server frissítése előtt olvassa el az <a target=\\\\"_blank\\\\" href=\\\\"https://www.synology.com/knowledgebase/DSM/tutorial/Collaboration/What_do_I_need_to_know_before_upgrading_from_Cloud_Station_to_Synology_Drive_2_0\\\\">itt</a> található információkat.\\\"+\\\"</span>\\\"}));form.doLayout()}if(isCloudStationMigrate||isShareSyncMigrate){var container=arguments[1];var nextStepButton=container.owner.getFooterToolbar().getComponent('next');var backStepButton=container.owner.getFooterToolbar().getComponent('back');var clickEventListeners=[];nextStepButton.mons.forEach(function(item){if(item.ename==='click'){clickEventListeners.push(item)}});clickEventListeners.forEach(function(item){nextStepButton.mun(item.item,item.ename,item.fn,item.scope)});var onClickNextButton=function(e){var msgDescription=\\\"\\\";if(isCloudStationMigrate&&isShareSyncMigrate){msgDescription=\\\"A telepítést követően a Synology Drive Server lép a Cloud Station Server és a Cloud Station ShareSync helyébe. A Rendszer áttelepíti a két alkalmazás beállításait. Biztosan továbblép?\\\"}else if(isCloudStationMigrate){msgDescription=\\\"A telepítést követően a Synology Drive Server lép a Cloud Station Server helyébe. A rendszer áttelepíti a Cloud Station Server beállításait. Biztosan továbblép?\\\"}else if(isShareSyncMigrate){msgDescription=\\\"A telepítést követően a Synology Drive Server lép a Cloud Station ShareSync helyébe. A Rendszer áttelepíti a Cloud Station ShareSync beállításait. Biztosan továbblép?\\\"}form.owner.getMsgBox().confirm(\\\"\\\",msgDescription,function(button){if(button==='yes'){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton);nextStepButton.el.dom.click()}})};var onClickBackButton=function(e){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton)};nextStepButton.mon(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mon(backStepButton.el,'click',onClickBackButton,backStepButton)}"

OFFICE_PKG_PATH="/var/packages/Spreadsheet/"
OFFICE_INFO_FILE=${OFFICE_PKG_PATH}"INFO"
CLOUDSTATION_PKG_PATH="/var/packages/CloudStation/"
CLOUDSTATION_DB_CONFIG_PATH=${CLOUDSTATION_PKG_PATH}"etc/db-path.conf"
CLOUDSTATION_USER_DB_RELATIVE_PATH="@cloudstation/@sync/user-db.sqlite"
CLOUDSTATIONCLIENT_PKG_PATH="/var/packages/CloudStationClient/"
VER_KEY="version"
OLD_OFFICE_MAJOR_VERSION=2
OLD_OFFICE_MINOR_VERSION=2

IsOfficeMigrate()
{
	if [ ! -f "${OFFICE_INFO_FILE}" ]; then
		return 0
	fi

	local office_major=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 1)
	local office_minor=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 2)

	if [ ${office_major} -lt ${OLD_OFFICE_MAJOR_VERSION} ] || [ ${office_major} -eq ${OLD_OFFICE_MAJOR_VERSION} -a ${office_minor} -le ${OLD_OFFICE_MINOR_VERSION} ]; then
		return 1
	fi
	return 0
}

IsCloudStationMigrate()
{
	if [ -d ${CLOUDSTATION_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

IsCloudStationClientMigrate()
{
	if [ -d ${CLOUDSTATIONCLIENT_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

IsClientUpgradeNeeded()
{
	IsCloudStationMigrate
	local cloud_station_migrate=$?

	if [ "${cloud_station_migrate}" = "0" ]; then
		return 0
	fi

	if [ ! -f "${CLOUDSTATION_DB_CONFIG_PATH}" ]; then
		return 0
	fi

	local db_volume=$(/usr/bin/get_key_value "${CLOUDSTATION_DB_CONFIG_PATH}" "db-vol")

	if [ -z "${db_volume}" ]; then
		return 0
	fi

	local user_db_path="${db_volume}/${CLOUDSTATION_USER_DB_RELATIVE_PATH}"

	if [ -f "${user_db_path}" ]; then
		local result=$(/usr/bin/sqlite3 "${user_db_path}" "SELECT EXISTS (SELECT 1 FROM session_table as st, user_table as ut WHERE ut.id = st.uid);")

		if [ "$result" = "1" ]; then
			return 1
		fi
	fi

	return 0
}

main()
{
	local InstallPages=""
	IsOfficeMigrate
	local office_migrate=$?
	IsCloudStationMigrate
	local cloud_migrate=$?
	IsCloudStationClientMigrate
	local sharesync_migrate=$?
	IsClientUpgradeNeeded
	local client_upgrade_needed=$?

	if [ "$office_migrate" = "0" ] && [ "$cloud_migrate" = "0" ] && [ "$sharesync_migrate" = "0" ]; then
		InstallPages=""
	else
		local title=${PKG_STR_WIZARD_UPDATE_TITLE}
		local description
		local activate=${PKG_STR_WIZARD_INSTALL_ACTIVATE}

		if [ "$office_migrate" = "0" ]; then
			description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD}
		else
			if [ "$cloud_migrate" = "1" ] || [ "$sharesync_migrate" = "1" ]; then
				description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE}
			else
				description=${PKG_STR_WIZARD_UPDATE_DESC_OFFICE}
			fi
		fi

		if [ "$office_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/false/g'`
		fi
		if [ "$cloud_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/false/g'`
		fi
		if [ "$sharesync_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/false/g'`
		fi
		if [ "$client_upgrade_needed" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLINET_UPGRADE_NEEDED__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLINET_UPGRADE_NEEDED__/false/g'`
		fi

		InstallPages=`/bin/cat<<EOF
{
	"step_title": "${title}",
	"activeate": "{${activate}}",
	"items": [{
		"desc": "${description}"
	}]
}
EOF`
	fi

/bin/cat > ${SYNOPKG_TEMP_LOGFILE} <<EOF
[${InstallPages}]
EOF

	exit 0
}

main "$@"
