#!/bin/sh

PKG_STR_WIZARD_UPDATE_TITLE="Zainstaluj Synology Drive Server"
PKG_STR_WIZARD_UPDATE_DESC_CLOUD="Synology Drive Server jest następcą Cloud Station."
PKG_STR_WIZARD_UPDATE_DESC_OFFICE="Synology Drive Server jest uniwersalnym portalem plików, który integruje pakiet Synology Office."
PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE="Synology Drive Server jest następcą Cloud Station i służy jako portal dla Synology Office."

PKG_STR_WIZARD_INSTALL_ACTIVATE="var form=arguments[0];var isCloudStationMigrate=__IS_CLOUD_MIGRATE__,isShareSyncMigrate=__IS_SHARESYNC_MIGRATE__,isOfficeMigrate=__IS_OFFICE_MIGRATE__,isClientUpgradeNeeded=__IS_CLINET_UPGRADE_NEEDED__;if(1===form.items.items.length){var note=\\\"\\\";if(isCloudStationMigrate){note+=\\\"<li>\\\"+\\\"<b>Cloud Station Server</b> zostanie zastąpiony: dane i ustawienia w <b>Cloud Station Server</b> zostaną przeniesione do <b>Synology Drive Server</b>\\\"+\\\"</li>\\\"}if(isClientUpgradeNeeded){note+=\\\"<li>\\\"+\\\"Przed uaktualnieniem do <b>Synology Drive Server</b> pamiętaj, że wszystkie aplikacje pakietu Cloud Station Suite (Cloud Station Drive, Backup, ShareSync lub DS cloud) należy przełączyć na ich odpowiedniki w pakiecie Synology Drive Suite, aby zapewnić kompatybilność.\\\"+\\\"</li>\\\"}if(isShareSyncMigrate){note+=\\\"<li>\\\"+\\\"<b>Cloud Station ShareSync</b> zostanie zastąpiona: dane i ustawienia <b>Cloud Station ShareSync</b> zostaną bezpiecznie przeniesione do <b>Synology Drive Server</b>\\\"+\\\"</li>\\\"}if(isOfficeMigrate){note+=\\\"<li>\\\"+\\\"<b>Synology Office</b> zostanie zintegrowany: dane w pakiecie <b>Synology Office</b> zostaną bezpiecznie przeniesione na <b>Synology Drive Server</b> i będzie można je otworzyć za pośrednictwem uniwersalnego portalu <b>Synology Drive</b>.\\\"+\\\"</li>\\\"}note+=\\\"<li>\\\"+\\\"Cofnięcie aktualizacji jest nie obsługiwane.\\\"+\\\"</li>\\\";form.add(new SYNO.ux.DisplayField({htmlEncode:false,value:\\\"Przed zainstalowaniem Synology Drive Server należy pamiętać, że:\\\"+\\\"<br>\\\"+\\\"<ul style='padding-left:5px;list-style:disc inside;'>\\\"+note+\\\"</ul><br><span>\\\"+\\\"Wejdź <a target=\\\\"_blank\\\\" href=\\\\"https://www.synology.com/knowledgebase/DSM/tutorial/Collaboration/What_do_I_need_to_know_before_upgrading_from_Cloud_Station_to_Synology_Drive_2_0\\\\">tutaj</a>, aby uzyskać więcej informacji przed uaktualnieniem do Synology Drive Server.\\\"+\\\"</span>\\\"}));form.doLayout()}if(isCloudStationMigrate||isShareSyncMigrate){var container=arguments[1];var nextStepButton=container.owner.getFooterToolbar().getComponent('next');var backStepButton=container.owner.getFooterToolbar().getComponent('back');var clickEventListeners=[];nextStepButton.mons.forEach(function(item){if(item.ename==='click'){clickEventListeners.push(item)}});clickEventListeners.forEach(function(item){nextStepButton.mun(item.item,item.ename,item.fn,item.scope)});var onClickNextButton=function(e){var msgDescription=\\\"\\\";if(isCloudStationMigrate&&isShareSyncMigrate){msgDescription=\\\"Cloud Station Server i Cloud Station ShareSync zostaną zastąpione przez Synology Drive Server po instalacji, a ich ustawienia zostaną przeniesione. Czy chcesz kontynuować?\\\"}else if(isCloudStationMigrate){msgDescription=\\\"Cloud Station Server zostanie zastąpiony przez Synology Drive Server po instalacji, a jego ustawienia zostaną przeniesione. Czy chcesz kontynuować?\\\"}else if(isShareSyncMigrate){msgDescription=\\\"Aplikacja Cloud Station ShareSync zostanie zastąpiona przez Synology Drive Server po instalacji, a jej ustawienia zostaną przeniesione. Czy chcesz kontynuować?\\\"}form.owner.getMsgBox().confirm(\\\"\\\",msgDescription,function(button){if(button==='yes'){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton);nextStepButton.el.dom.click()}})};var onClickBackButton=function(e){clickEventListeners.forEach(function(item){nextStepButton.mon(item.item,item.ename,item.fn,item.scope)});nextStepButton.mun(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mun(backStepButton.el,'click',onClickBackButton,backStepButton)};nextStepButton.mon(nextStepButton.el,'click',onClickNextButton,nextStepButton);backStepButton.mon(backStepButton.el,'click',onClickBackButton,backStepButton)}"

OFFICE_PKG_PATH="/var/packages/Spreadsheet/"
OFFICE_INFO_FILE=${OFFICE_PKG_PATH}"INFO"
CLOUDSTATION_PKG_PATH="/var/packages/CloudStation/"
CLOUDSTATION_DB_CONFIG_PATH=${CLOUDSTATION_PKG_PATH}"etc/db-path.conf"
CLOUDSTATION_USER_DB_RELATIVE_PATH="@cloudstation/@sync/user-db.sqlite"
CLOUDSTATIONCLIENT_PKG_PATH="/var/packages/CloudStationClient/"
VER_KEY="version"
OLD_OFFICE_MAJOR_VERSION=2
OLD_OFFICE_MINOR_VERSION=2

IsOfficeMigrate()
{
	if [ ! -f "${OFFICE_INFO_FILE}" ]; then
		return 0
	fi

	local office_major=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 1)
	local office_minor=$(/bin/get_key_value "${OFFICE_INFO_FILE}" "${VER_KEY}" | cut -d '.' -f 2)

	if [ ${office_major} -lt ${OLD_OFFICE_MAJOR_VERSION} ] || [ ${office_major} -eq ${OLD_OFFICE_MAJOR_VERSION} -a ${office_minor} -le ${OLD_OFFICE_MINOR_VERSION} ]; then
		return 1
	fi
	return 0
}

IsCloudStationMigrate()
{
	if [ -d ${CLOUDSTATION_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

IsCloudStationClientMigrate()
{
	if [ -d ${CLOUDSTATIONCLIENT_PKG_PATH} ]; then
		return 1
	fi
	return 0
}

IsClientUpgradeNeeded()
{
	IsCloudStationMigrate
	local cloud_station_migrate=$?

	if [ "${cloud_station_migrate}" = "0" ]; then
		return 0
	fi

	if [ ! -f "${CLOUDSTATION_DB_CONFIG_PATH}" ]; then
		return 0
	fi

	local db_volume=$(/usr/bin/get_key_value "${CLOUDSTATION_DB_CONFIG_PATH}" "db-vol")

	if [ -z "${db_volume}" ]; then
		return 0
	fi

	local user_db_path="${db_volume}/${CLOUDSTATION_USER_DB_RELATIVE_PATH}"

	if [ -f "${user_db_path}" ]; then
		local result=$(/usr/bin/sqlite3 "${user_db_path}" "SELECT EXISTS (SELECT 1 FROM session_table as st, user_table as ut WHERE ut.id = st.uid);")

		if [ "$result" = "1" ]; then
			return 1
		fi
	fi

	return 0
}

main()
{
	local InstallPages=""
	IsOfficeMigrate
	local office_migrate=$?
	IsCloudStationMigrate
	local cloud_migrate=$?
	IsCloudStationClientMigrate
	local sharesync_migrate=$?
	IsClientUpgradeNeeded
	local client_upgrade_needed=$?

	if [ "$office_migrate" = "0" ] && [ "$cloud_migrate" = "0" ] && [ "$sharesync_migrate" = "0" ]; then
		InstallPages=""
	else
		local title=${PKG_STR_WIZARD_UPDATE_TITLE}
		local description
		local activate=${PKG_STR_WIZARD_INSTALL_ACTIVATE}

		if [ "$office_migrate" = "0" ]; then
			description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD}
		else
			if [ "$cloud_migrate" = "1" ] || [ "$sharesync_migrate" = "1" ]; then
				description=${PKG_STR_WIZARD_UPDATE_DESC_CLOUD_OFFICE}
			else
				description=${PKG_STR_WIZARD_UPDATE_DESC_OFFICE}
			fi
		fi

		if [ "$office_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_OFFICE_MIGRATE__/false/g'`
		fi
		if [ "$cloud_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLOUD_MIGRATE__/false/g'`
		fi
		if [ "$sharesync_migrate" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_SHARESYNC_MIGRATE__/false/g'`
		fi
		if [ "$client_upgrade_needed" = "1" ]; then
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLINET_UPGRADE_NEEDED__/true/g'`
		else
			activate=`/usr/bin/echo $activate | /usr/bin/sed 's/__IS_CLINET_UPGRADE_NEEDED__/false/g'`
		fi

		InstallPages=`/bin/cat<<EOF
{
	"step_title": "${title}",
	"activeate": "{${activate}}",
	"items": [{
		"desc": "${description}"
	}]
}
EOF`
	fi

/bin/cat > ${SYNOPKG_TEMP_LOGFILE} <<EOF
[${InstallPages}]
EOF

	exit 0
}

main "$@"
