#!/bin/bash
# Copyright (c) 2020 Synology Inc. All rights reserved.

BuildApparmor()
{
    local folder="$1"
	echo "building apparmor cache..."
	BuildAppArmorCache "SynologyDrive" "server/package/$folder/apparmor" 2>&1 | grep -v Warning
	echo "building apparmor cache done."
}

InstallApparmor()
{
    local folder="$1"
	echo "installing apparmor cache..."
	InstallAppArmorCache "SynologyDrive" $INST_DIR "server/package/$folder/apparmor"
	echo "installing apparmor cache done."
}

IncludeProjects=""
INST_DIR="/tmp/_synodrive"
PKG_DIR="/tmp/_synodrive_pkg"
PKG_DEST="/image/packages"
PKG_DSM_UI_DIR_NAME=ui         # dsm folder name for replace version in dsm conifg and create indexdb
PKG_DSM_HELP_DIR=$INST_DIR      # help folder for replace DSM variable (ex:$_DSPRODUCTNAME_$) in help
PKG_DSM_CONF_VER_STR="__PKG_VERSION__" # string in config to be replaced
THIS_PROJECT=`pwd | awk -F'/' '{print $3}'`
UISTRING_PATH="/source/uistring/drive"

. ../../../../detect-env.sh

Usage() {
	cat >&2 <<EOF
USAGE: $(basename $0) <action> <folder>
ACTION:
	build
	install
EOF
	exit 0
}

[ $# -eq 0 ] && Usage

Action=$1
Folder=$2

case "$Action" in
	build)	BuildApparmor "$Folder" ;;
	install)	InstallApparmor "$Folder" ;;
	*)		Usage ;;
esac
